//
//  CFGSocket.m
//  FGHelloDevice
//
//  Created by Francesco on 5/4/06.
//  Copyright 2006 Softech di Germinara Francesco. All rights reserved.
//  tcpdump -l -s 600 -q -x -e udp port bootps
//  deve girare come root
//  fare immissione indirizzo ip e estrazione bytes da ip address



#import "CFGSocket.h"

#import "netDB.h"
#import <sys/time.h>

@implementation CFGSocket

- (id) init {
	self = [super init];
	if (self != nil) {
     int i=0;
	 for(i=0;i<4;i++)
      StatoIO.IOStatus[i]=0x00;
  
      m_OpenConnection=FALSE;	
	  idFile=-1;
  	}
	return self;
}


- (void) dealloc {
	[self CloseConnection];
	[super dealloc];
}

//Close the connection
- (void) CloseConnection{
 if(idFile != -1)
  close(idFile);
 m_OpenConnection=FALSE;
 idFile=-1;
}

//Crea il Socket per la comunicazione
- (BOOL) CreateSocket:(NSString*) ipAddress withPort:(unsigned int) port{
 BOOL sts=FALSE;  
 int result=0;
 if(idFile != -1){ //Connection already present
  sts=TRUE;
 }else{
 idFile = socket(AF_INET,SOCK_STREAM,0);
 [self initDevice:ipAddress withPort:port]; //inizializzo le strutture per la comunicazzione con il device
 result=connect(idFile,(struct sockaddr *) &clientAddr,sizeof(clientAddr));
 if(result != -1)
  m_OpenConnection=TRUE;
 } 
 return sts;
}

-(void)initDevice:(NSString*) ipAddress withPort:(unsigned int) nPort{

  ipAddr=0 ;
  struct hostent *hostinfo;
  hostinfo=gethostbyname([ipAddress UTF8String]);
  
  memcpy(&ipAddr, hostinfo->h_addr_list[0], hostinfo->h_length);	
	
	// Clear IP address fields
	memset( (char*) &addr, 0, sizeof( addr ) );
	memset( (char*) &clientAddr, 0, sizeof( clientAddr ) ); 

	// Set my IP address : TCP port 
	addr.sin_family = AF_INET;
	addr.sin_port = htons(nPort);	
	addr.sin_addr.s_addr = INADDR_ANY;

	clientAddr.sin_family = AF_INET;
	clientAddr.sin_port = htons(nPort);
	clientAddr.sin_addr.s_addr = htonl(ipAddr);
	
	clientLenght = sizeof(clientAddr);
}

//Leggo stato di Input e Output
-(BOOL) ReadStatus{
   char commandBuf, *responseBuf=NULL;
   int  commandLen;
   int nLenReceived=0;
   BOOL sts=FALSE;   
   int i=0; 
   
   //Command buffer
   commandBuf=IOGet;
   commandLen=1;
   
   //Response buffer
   responseBuf=(char*) calloc(0x10,1);
   memset(responseBuf,'A',0x10);
   
   if(write(idFile,&commandBuf,commandLen)!=-1){ //Ok,
	nLenReceived=read(idFile,responseBuf,0x10);
	 if(nLenReceived==4){
      for(i=0; i<4; i++)
       StatoIO.IOStatus[i]=responseBuf[i];
      sts=TRUE;  
	 }
   }
   free(responseBuf);
   
	  
   // Debug only 
   NSString *msg;
   msg=[[NSString alloc] initWithFormat:@"Valori letti: Input: [%x] [%x] OutPut: [%x] [%x]",StatoIO.IOStatus[0],StatoIO.IOStatus[1],StatoIO.IOStatus[2],StatoIO.IOStatus[3]];
   NSLog(msg);
   [msg release];
  
    return sts;
}

//Imposto il valore del bit specificato
-(void)SetBit:(int) nBit withStatus:(BOOL) sts{
 if(nBit<0)
  return; //NOP
 
 dato.byte=word.bytes.msb;
 switch(nBit){
  case 0: dato.bit.b0=sts; break;
  case 1: dato.bit.b1=sts; break;
  case 2: dato.bit.b2=sts; break;
  case 3: dato.bit.b3=sts; break;
  case 4: dato.bit.b4=sts; break;
  case 5: dato.bit.b5=sts; break;
  case 6: dato.bit.b6=sts; break;
  case 7: dato.bit.b7=sts; break;
 }
 word.bytes.msb=dato.byte;

 dato.byte=word.bytes.lsb;
 switch(nBit){
  case  8: dato.bit.b0=sts; break;
  case  9: dato.bit.b1=sts; break;
  case 10: dato.bit.b2=sts; break;
  case 11: dato.bit.b3=sts; break;
  case 12: dato.bit.b4=sts; break;
  case 13: dato.bit.b5=sts; break;
  case 14: dato.bit.b6=sts; break;
  case 15: dato.bit.b7=sts; break;
 }
 word.bytes.lsb=dato.byte;
 
 StatoIO.porta.output.dw=word.dw;
}

//Imposto il valore del bit specificato
-(void)SetBitAsString:(NSString*) strNBit withStatus:(BOOL) sts{
 int nBit=0;
 if([strNBit isEqualToString:@""] || [strNBit isEqualToString:@"  "])
  return; //NOP
 nBit=[strNBit intValue];
 [self SetBit:nBit withStatus:sts];
}


//Restituisce il valore del bit specificato
-(BOOL) GetBit:(int) nBit{
 if(nBit<8){
  dato.byte=word.bytes.msb;
  switch(nBit){
   case 0: return dato.bit.b0;
   case 1: return dato.bit.b1;
   case 2: return dato.bit.b2;
   case 3: return dato.bit.b3;
   case 4: return dato.bit.b4;
   case 5: return dato.bit.b5;
   case 6: return dato.bit.b6;
   case 7: return dato.bit.b7;
   default: return FALSE;
  }
 }else{
  dato.byte=word.bytes.lsb;
  switch(nBit){
   case  8: return dato.bit.b0; 
   case  9: return dato.bit.b1;
   case 10: return dato.bit.b2;
   case 11: return dato.bit.b3;
   case 12: return dato.bit.b4;
   case 13: return dato.bit.b5;
   case 14: return dato.bit.b6;
   case 15: return dato.bit.b7;
   default: return FALSE;
  }
 }
}

//Restituisce il valore del bit specificato
-(BOOL) GetBitAsString:(NSString*) strNBit{
 int nBit=0;
 nBit=[strNBit intValue];
 return [self GetBit:nBit];
}

-(NSString*) ShowInputStatus{
 NSMutableString *msgStsInp;
 msgStsInp=[NSMutableString stringWithString:@"Stato Input: "];
 BOOL sts=0;
 int i=0;
 word.dw = StatoIO.porta.input.dw;

 for(i=0; i< 16; i++){
  sts=[self GetBit:i];
  [msgStsInp appendFormat:@"b%02d[%s] ",i, sts==0 ? "Off" : "On"];
 }
 return msgStsInp;
}

-(NSString*) ShowOutputStatus{
 NSMutableString *msgStsOut;
 msgStsOut=[NSMutableString stringWithString:@"Stato Output: "];
 BOOL sts=0;
 int i=0;
 word.dw = StatoIO.porta.output.dw;

 for(i=0; i< 16; i++){
  sts=[self GetBit:i];
  [msgStsOut appendFormat:@"b%02d[%s] ",i, sts==0 ? "Off" : "On"];
 }
 return msgStsOut;
}


//Imposto stato Output
-(BOOL) SetOutput{
   char commandBuf[3];
   int  commandLen;
   
   commandBuf[0]=IOSet;
   commandBuf[1]=(unsigned char)StatoIO.porta.output.bytes.lsb;
   commandBuf[2]=(unsigned char)StatoIO.porta.output.bytes.msb;
   
   commandLen=3;
   BOOL sts=FALSE;   
   if(write(idFile,commandBuf,commandLen)!=-1){ //Ok,
    sts=true;
   }
   
   //sleep(50);
   return sts;
}


-(BOOL) GetInputStatus:(int) nBit useInvertedState:(BOOL) bInverted{
 BOOL sts=0;
 word.dw = StatoIO.porta.input.dw;
 sts=[self GetBit:nBit];
 if(bInverted)
  sts=!sts;
 return sts;
}

-(BOOL)GetOutputStatus:(int) nBit{
 BOOL sts=0;
 word.dw = StatoIO.porta.output.dw;
 sts=[self GetBit:nBit];
 return sts;
}

-(void) SetOutputStatus:(int) nBit withStatus:(BOOL) status{
 word.dw = StatoIO.porta.output.dw;
 [self SetBit:nBit withStatus:status];
 StatoIO.porta.output.dw=word.dw;
}

-(void) SetAllOutputStatus:(BOOL) status{
 int i=0;
 for(i=0;i<16;i++)
  [self SetOutputStatus:i withStatus:status];
 [self SetOutput];  
}


//Crea il Socket per la comunicazione UDP
- (BOOL) CreateSocketDGRAM:(NSString*) ipAddress withPort:(unsigned int) port{
 BOOL sts=FALSE;  
 int result=0;
 if(idFile != -1){ //Connection already present
  sts=TRUE;
 }else{
 idFile = socket(AF_INET,SOCK_DGRAM,0);
 [self initDevice:ipAddress withPort:port]; //inizializzo le strutture per la comunicazzione con il device

 int yes=1;
 result=setsockopt(idFile,SOL_SOCKET,SO_REUSEADDR,&yes,sizeof(int));

 result=bind(idFile,(struct sockaddr *) &addr,sizeof(addr));
 if(result != -1)
  m_OpenConnection=TRUE;
 } 
 return sts;
}

- (void) clearIP{
  unsigned char commandbuf[5] ;
  commandbuf[0] = IC_COMMAND ;
  sendto(idFile,commandbuf,1,0,(struct sockaddr *) &clientAddr,sizeof(clientAddr));
}


- (void) bootPwithIPB0:(int)ipB0 ipB1:(int)ipB1 ipB2:(int)ipB2 ipB3:(int)ipB3
       withGWB0:(int)gwB0 gwB1:(int)gwB1 gwB2:(int)gwB2 gwB3:(int)gwB3
       withNMB0:(int)nmB0 nmB1:(int)nmB1 nmB2:(int)nmB2 nmb3:(int)nmB3
	   macAddressInfo:(NSTextField *)theMacAddress
{

 int result=0;
 int yes=1;
 unsigned char buffer[300] ;
 unsigned char sendBuff[300] ;
 unsigned int mac[6] ;
 
 socklen_t len=0;
  
 char szHostName[50];
 memset (szHostName, 0, sizeof(szHostName));
 if (gethostname(szHostName, sizeof(szHostName)) != 0) {
  NSLog(@"Errore: gethostname()");
  return;
 }
 NSLog(@"Computer Name: %s",szHostName);
 
  struct hostent *hostinfo;
  hostinfo=gethostbyname(szHostName);
  
  memcpy (&hostAddr, hostinfo->h_addr, 4);

 idFile = socket(AF_INET,SOCK_DGRAM,0); //DGRAM
 result=setsockopt(idFile,SOL_SOCKET,SO_REUSEADDR ,&yes,sizeof(int));
 
 struct timeval tv;
 tv.tv_sec = 0;
 tv.tv_usec = RTSOCK_TIMEOUT_USECS;
 setsockopt(idFile, SOL_SOCKET, SO_RCVTIMEO, (caddr_t)&tv,sizeof(tv));

 // Clear IP address fields
 memset( (char*) &addr, 0, sizeof( addr ) );
 // Set my IP address : TCP port 
 addr.sin_family = AF_INET;
 addr.sin_port = htons(67);	
 addr.sin_addr.s_addr = htonl(INADDR_ANY); 
 memset(addr.sin_zero, 0, sizeof( addr.sin_zero ) );

 result=bind(idFile,(struct sockaddr *) &addr,sizeof(addr));
 if(result != -1)
  m_OpenConnection=TRUE;
 if(result == -1){
  NSLog(@"Errore bind(): %s",strerror(errno));
  NSRunAlertPanel(@"Error!",@"Try with root user.",@"OK",nil,nil);  
  }
 
  if(m_OpenConnection){
        result=recvfrom(idFile,buffer,300,0,(struct sockaddr *) &addr,&len);
		
       if(result == -1){
        NSLog(@"Errore recvfrom(): %s",strerror(errno));
        NSRunAlertPanel(@"Error!",@"No response from device. Timeout expired",@"OK",nil,nil);  
		return;
       }
		

		unsigned int MAC1, MAC2, MAC3 ;
		MAC1 = buffer[28] ;
		MAC2 = buffer[29] ;
		MAC3 = buffer[30] ;
		if ( (MAC1 != 0x00) || (MAC2 != 0x01) || (MAC3 != 0x95) )	// Not HelloDevice !
		{
		  NSLog(@"Non e' un hellodevice...");
		  return;
		}
		
		if(buffer[0] == 1){
		 NSLog(@"BootP Socket Accepted..") ;
		}
		else 
		{
		  NSLog(@"Non e' bootp...");
		  return;
		}
		
		int i=0;
		for(i =0; i<6; i++) 
		 mac[i] = buffer[28+i] ;
		
		NSString *strMacAddres=[self MACtoString:mac];
		
		[theMacAddress setStringValue:strMacAddres];
		[theMacAddress setNeedsDisplay:YES];
		
		NSLog(@"Mac address: %@",strMacAddres);
		int p=0;
		for (p =0 ; p <300 ; p++)
			sendBuff[p] = buffer[p] ;

		sendBuff[0] = 2 ; 
		sendBuff[1] = 1 ;
		sendBuff[2] = 6 ;

        //Ip for client
		sendBuff[16] = (unsigned char) ipB0 ;	
		sendBuff[17] = (unsigned char) ipB1 ;
		sendBuff[18] = (unsigned char) ipB2  ;	
		sendBuff[19] = (unsigned char) ipB3 ;  

		// My IP
        sendBuff[20] =  hostAddr.bytes[0]; //192 ;
        sendBuff[21] =  hostAddr.bytes[1]; //168 ;
        sendBuff[22] =  hostAddr.bytes[2]; //33  ;
        sendBuff[23] =  hostAddr.bytes[3]; //100 ;

        //gateway
		sendBuff[24] = (unsigned char) gwB0;
		sendBuff[25] = (unsigned char) gwB1;
		sendBuff[26] = (unsigned char) gwB2;
		sendBuff[27] = (unsigned char) gwB3;

		sendBuff[242] = (unsigned char) nmB0;
		sendBuff[243] = (unsigned char) nmB1;
		sendBuff[244] = (unsigned char) nmB2;
		sendBuff[245] = (unsigned char) nmB3;

        addr.sin_port = htons(68);	
		addr.sin_addr.s_addr = htonl(0xffffffff); 		
        result=setsockopt(idFile,SOL_SOCKET,SO_BROADCAST,&yes,sizeof(int));

	    result=sendto(idFile,sendBuff,300,0,(struct sockaddr *) &addr,sizeof(addr));
    	if(result == -1)
 		 NSLog(@"Errore  sendto(): %d %s",errno,strerror(errno));
		
        if (result!=-1) {
		 NSLog(@"Ip changed");
		 NSRunAlertPanel(@"Information",@"New IP setting",@"OK",nil,nil);
	   	}
  }
 } 


-(NSString*) MACtoString:(unsigned int *) mac { 
    NSMutableString *aStrResult;
	aStrResult=[NSMutableString stringWithString:@""];
    int i=0;	
	for(i=0 ; i <6 ;i++) 
	{
		if (mac[i] <0x10)
		 [aStrResult appendFormat:@"0%X:",mac[i]];
		else{
		 [aStrResult appendFormat:@"%X:",mac[i]];
		}
	}
    [aStrResult deleteCharactersInRange:NSMakeRange([aStrResult length]-1,1)];
	return aStrResult ;
}	






@end
